define([
    "dojo/_base/declare",
    "dijit/Destroyable",
    "epi/shell/command/_Command",
    "./views/content-children-selector/children-selector-dialog",
    "epi-cms/contentediting/DialogPositionAdjust",
    "advanced-cms-bulk-edit/show-bulk-edit-dialog"
], function (
    declare,
    Destroyable,
    _Command,
    ChildrenSelectorDialog,
    DialogPositionAdjust,
    showBulkEditDialog
) {
    return declare([_Command, Destroyable], {
        label: "Bulk edit",

        iconClass: "epi-iconForms",

        constructor: function () {
            this.inherited(arguments);

            this._dialogPositionAdjust = new DialogPositionAdjust();
            this.own(this._dialogPositionAdjust);
        },

        _execute: function () {
            var dialog = new ChildrenSelectorDialog();
            dialog.selectContentLinks(this.model.contentLink).then(function (contents) {
                if (contents) {
                    showBulkEditDialog(this._dialogPositionAdjust, contents).then(function () {

                    }.bind(this));
                }
            }.bind(this));
        },

        _onModelChange: function () {
            this.inherited(arguments);

            if (this.model === null) {
                this.set("canExecute", false);
                this.set("isAvailable", false);
                return;
            }

            this.set("isAvailable", this.model.hasChildren);
            this.set("canExecute", this.model.hasChildren);
        }
    });
});
